Zombie = {}

if select(2, UnitClass("player")) ~= "DEATHKNIGHT" then
    DisableAddOn("Zombie")
    return
end

SLASH_Zombie1 = "/zombie"

local function InitializeVariables()
	Zombie.locked = Zombie.locked == nil and false or Zombie.locked
	Zombie.scale = Zombie.scale == nil and 1 or Zombie.scale
	Zombie.frequency = Zombie.frequency == nil and 0.05 or Zombie.frequency
	Zombie.latency = Zombie.latency == nil and 0.3 or Zombie.latency
	Zombie.misseffect = Zombie.misseffect == nil and true or Zombie.misseffect
	Zombie.aoe = Zombie.aoe == nil and 3 or Zombie.aoe
	Zombie.aoelabel = Zombie.aoelabel == nil and true or Zombie.aoelabel
	Zombie.glow = Zombie.glow == nil and true or Zombie.glow
	Zombie.boss = Zombie.boss == nil and false or Zombie.boss
	Zombie.army = Zombie.army == nil and false or Zombie.army
	Zombie.bloodtap = Zombie.bloodtap == nil and true or Zombie.bloodtap
	Zombie.erw = Zombie.erw == nil and false or Zombie.erw
	Zombie.pillar = Zombie.pillar == nil and true or Zombie.pillar
	Zombie.gargoyle = Zombie.gargoyle == nil and false or Zombie.gargoyle
	Zombie.raisedead = Zombie.raisedead == nil and false or Zombie.raisedead
end

local events, targetHealthArray, aoeTargets = {}, {}, {}
local lastAbilityCalculation, GCD, currentTime, combatStartTime, aoeStartTime, frostFeverCastTime, bloodPlagueCastTime, pointsInEpidemic, pointsInChillOfTheGrave = 0, 0, 0, 0, 0, 0, 0, 0, 0
local actionButtonMoved, hostileTargetted, howlingBlastGlyphed, frostStrikeGlyphed = false, false, false, false
local zombiePanel = CreateFrame("Frame", "zombiePanel", UIParent)
zombiePanel:SetPoint("CENTER", 0, -155)
zombiePanel:SetFrameStrata("BACKGROUND")
zombiePanel:Hide()
zombiePanel:RegisterForDrag("LeftButton")
zombiePanel:SetScript("OnDragStart", zombiePanel.StartMoving)
zombiePanel:SetScript("OnDragStop", zombiePanel.StopMovingOrSizing)
zombiePanel:SetMovable(true)
zombiePanel.icon = zombiePanel:CreateTexture(nil, "BACKGROUND")
zombiePanel.icon:SetAllPoints(zombiePanel)
zombiePanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
zombiePanel.border = zombiePanel:CreateTexture(nil, "BORDER")
zombiePanel.border:SetAllPoints(zombiePanel)
zombiePanel.border:SetTexture("Interface\\AddOns\\Zombie\\border.blp")
zombiePanel.border:Hide()
zombiePanel.aoelabel = zombiePanel:CreateTexture(nil, "BORDER")
zombiePanel.aoelabel:SetAllPoints(zombiePanel)
zombiePanel.aoelabel:SetTexture("Interface\\AddOns\\Zombie\\aoelabel.blp")
zombiePanel.aoelabel:Hide()
local zombieNextPanel = CreateFrame("Frame", "zombieNextPanel", UIParent)
zombieNextPanel:SetPoint("BOTTOMLEFT", zombiePanel, "BOTTOMRIGHT", 10, -5)
zombieNextPanel:SetFrameStrata("BACKGROUND")
zombieNextPanel:Hide()
zombieNextPanel:RegisterForDrag("LeftButton")
zombieNextPanel:SetScript("OnDragStart", zombieNextPanel.StartMoving)
zombieNextPanel:SetScript("OnDragStop", zombieNextPanel.StopMovingOrSizing)
zombieNextPanel:SetMovable(true)
zombieNextPanel.icon = zombieNextPanel:CreateTexture(nil, "BACKGROUND")
zombieNextPanel.icon:SetAllPoints(zombieNextPanel)
zombieNextPanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
zombieNextPanel.border = zombieNextPanel:CreateTexture(nil, "BORDER")
zombieNextPanel.border:SetAllPoints(zombieNextPanel)
zombieNextPanel.border:SetTexture("Interface\\AddOns\\Zombie\\border.blp")
local zombiePreviousPanel = CreateFrame("Frame", "zombiePreviousPanel", UIParent)
zombiePreviousPanel:SetPoint("BOTTOMRIGHT", zombiePanel, "BOTTOMLEFT", -10, -5)
zombiePreviousPanel:SetFrameStrata("BACKGROUND")
zombiePreviousPanel:Hide()
zombiePreviousPanel:RegisterForDrag("LeftButton")
zombiePreviousPanel:SetScript("OnDragStart", zombiePreviousPanel.StartMoving)
zombiePreviousPanel:SetScript("OnDragStop", zombiePreviousPanel.StopMovingOrSizing)
zombiePreviousPanel:SetMovable(true)
zombiePreviousPanel.icon = zombiePreviousPanel:CreateTexture(nil, "BACKGROUND")
zombiePreviousPanel.icon:SetAllPoints(zombiePreviousPanel)
zombiePreviousPanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
zombiePreviousPanel.border = zombiePreviousPanel:CreateTexture(nil, "BORDER")
zombiePreviousPanel.border:SetAllPoints(zombiePreviousPanel)
zombiePreviousPanel.border:SetTexture("Interface\\AddOns\\Zombie\\border.blp")

local Ability, abilityList = {}, {}
Ability.__index = Ability

function Ability.add(spellId, isDoT, playerCastOnly, runeCost, cooldown)
    local ability = {}
    setmetatable(ability, Ability)
    ability.spellId = spellId
    ability.isDoT = isDoT
    ability.playerCastOnly = playerCastOnly
	ability.runeCost = runeCost or {0, 0, 0}
	ability.cooldownLength = cooldown or 0
	ability.actionButton = nil
    ability.name = GetSpellInfo(spellId)
    ability.icon = select(3, GetSpellInfo(spellId))
	if spellId ~= 0 then
		abilityList[#abilityList + 1] = ability
	end
    return ability
end

-- Death Knight abilities
local ArmyOfTheDead = Ability.add(42650, false, true, {1, 1, 1}, 600)
local BloodBoil = Ability.add(48721, false, true, {1, 0, 0})
local BloodPlague = Ability.add(55078, true, true)
local BloodTap = Ability.add(45529, false, true, nil, 60)
local DarkTransformation = Ability.add(63560, false, true, {0, 0, 1})
local DeathAndDecay = Ability.add(43265, true, true, {0, 0, 1}, 30)
local DeathCoil = Ability.add(47541, false, true)
local EmpowerRuneWeapon = Ability.add(47568, false, true, {-2, -2, -2}, 5)
local FesteringStrike = Ability.add(85948, false, true, {1, 1, 0})
local FrostFever = Ability.add(55095, true, true)
local FrostPresence = Ability.add(48266, false, true, {0, 1, 0})
local FrostStrike = Ability.add(49143, false, true)
local HornOfWinter = Ability.add(57330, false, false, nil, 20)
local HowlingBlast = Ability.add(49184, false, true, {0, 1, 0})
local IcyTouch = Ability.add(45477, false, true, {0, 1, 0})
local KillingMachine = Ability.add(51124, false, true)
local Obliterate = Ability.add(49020, false, true, {0, 1, 1})
local Outbreak = Ability.add(77575, false, true, nil, 60)
local Pestilence = Ability.add(50842, true, true, {1, 0, 0})
local PillarOfFrost = Ability.add(51271, false, true, {0, 1, 0}, 60)
local PlagueStrike = Ability.add(45462, false, true, {0, 0, 1})
local RaiseDead = Ability.add(46584, false, true, nil, 180)
local Rime = Ability.add(59052, false, true)
local RuneOfTheFallenCrusader = Ability.add(53365, false, true)
local ScourgeStrike = Ability.add(55090, false, true, {0, 0, 1})
local SuddenDoom = Ability.add(81340, false, true)
local SummonGargoyle = Ability.add(49206, true, true, nil, 180)
local UnholyFrenzy = Ability.add(49016, false, false, nil, 180)
local UnholyPresence = Ability.add(48265, false, true, {0, 0, 1})
-- Other class abilities
local AncientHysteria = Ability.add(90355, false, false)
local BattleShout = Ability.add(6673, false, false)
local Bloodlust = Ability.add(2825, false, false)
local Heroism = Ability.add(32182, false, false)
local TimeWarp = Ability.add(80353, false, false)
-- Non-existent spell
local NoSpell = Ability.add(0, false, false)

local abilityNow, oldAbilityNow, abilityNext, oldAbilityNext, abilityPrevious = NoSpell, NoSpell, NoSpell, NoSpell, NoSpell

function RuneCooldown(rune)
	local runeStart, runeDuration, runeReady = GetRuneCooldown(rune)
	return (runeReady or runeDuration - (currentTime - runeStart) <= Zombie.latency) and 0 or runeDuration - (GetTime() - runeStart) - Zombie.latency
end

function RuneCooldownNext(rune)
	local runeStart, runeDuration, runeReady = GetRuneCooldown(rune)
	return (runeReady or runeDuration - (currentTime - runeStart) <= GCD + Zombie.latency) and 0 or runeDuration - (GetTime() - runeStart) - GCD - Zombie.latency
end

local function BloodRunes()
    return (GetRuneType(1) == 4 and 0 or RuneCooldown(1) == 0 and 1 or 0) + (GetRuneType(2) == 4 and 0 or RuneCooldown(2) == 0 and 1 or 0)
end

local function BloodRunesNext()
    return (GetRuneType(1) == 4 and 0 or RuneCooldownNext(1) == 0 and 1 or 0) + (GetRuneType(2) == 4 and 0 or RuneCooldownNext(2) == 0 and 1 or 0) - abilityNow.runeCost[1]
end

local function FrostRunes()
    return (GetRuneType(5) == 4 and 0 or RuneCooldown(5) == 0 and 1 or 0) + (GetRuneType(6) == 4 and 0 or RuneCooldown(6) == 0 and 1 or 0)
end

local function FrostRunesNext()
    return (GetRuneType(5) == 4 and 0 or RuneCooldownNext(5) == 0 and 1 or 0) + (GetRuneType(6) == 4 and 0 or RuneCooldownNext(6) == 0 and 1 or 0) - abilityNow.runeCost[2]
end

local function UnholyRunes()
    return (GetRuneType(3) == 4 and 0 or RuneCooldown(3) == 0 and 1 or 0) + (GetRuneType(4) == 4 and 0 or RuneCooldown(4) == 0 and 1 or 0)
end

local function UnholyRunesNext()
    return (GetRuneType(3) == 4 and 0 or RuneCooldownNext(3) == 0 and 1 or 0) + (GetRuneType(4) == 4 and 0 or RuneCooldownNext(4) == 0 and 1 or 0) - abilityNow.runeCost[3]
end

local function DeathRunes()
    local deathRunes = 0
    for i = 1, 6 do
        if GetRuneType(i) == 4 and RuneCooldown(i) == 0 then deathRunes = deathRunes + 1 end
    end
    return deathRunes
end

local function DeathRunesNext()
    local deathRunes = 0
    for i = 1, 6 do
        if GetRuneType(i) == 4 and RuneCooldownNext(i) == 0 then deathRunes = deathRunes + 1 end
    end
    return deathRunes + (BloodRunesNext() < 0 and BloodRunesNext() or 0) + (FrostRunesNext() < 0 and FrostRunesNext() or 0) + (UnholyRunesNext() < 0 and UnholyRunesNext() or 0) + (abilityNow == BloodTap and 1 or 0)
end

function Ability:ready()
	return self:cooldown() <= 0 or self:cooldown() == DeathCoil:cooldown()
end

function Ability:readyNext()
	local runesReady = true
	if self.runeCost[1] == 1 and self.runeCost[2] == 0 and self.runeCost[3] == 0 then
		runesReady = BloodRunesNext() + DeathRunesNext() >= 1
	elseif self.runeCost[1] == 0 and self.runeCost[2] == 1 and self.runeCost[3] == 0 then
		runesReady = FrostRunesNext() + DeathRunesNext() >= 1
	elseif self.runeCost[1] == 0 and self.runeCost[2] == 0 and self.runeCost[3] == 1 then
		runesReady = UnholyRunesNext() + DeathRunesNext() >= 1
	elseif self.runeCost[1] == 1 and self.runeCost[2] == 1 and self.runeCost[3] == 0 then
		runesReady = (BloodRunesNext() >= 1 and FrostRunesNext() >= 1) or (DeathRunesNext() >= 1 and (BloodRunesNext() >= 1 or FrostRunesNext() >= 1)) or DeathRunesNext() >= 2
	elseif self.runeCost[1] == 1 and self.runeCost[2] == 0 and self.runeCost[3] == 1 then
		runesReady = (BloodRunesNext() >= 1 and UnholyRunesNext() >= 1) or (DeathRunesNext() >= 1 and (BloodRunesNext() >= 1 or UnholyRunesNext() >= 1)) or DeathRunesNext() >= 2
	elseif self.runeCost[1] == 0 and self.runeCost[2] == 1 and self.runeCost[3] == 1 then
		runesReady = (FrostRunesNext() >= 1 and UnholyRunesNext() >= 1) or (DeathRunesNext() >= 1 and (FrostRunesNext() >= 1 or UnholyRunesNext() >= 1)) or DeathRunesNext() >= 2
	elseif self.runeCost[1] == 1 and self.runeCost[2] == 1 and self.runeCost[3] == 1 then
		runesReady = (BloodRunesNext() >= 1 and FrostRunesNext() >= 1 and UnholyRunesNext() >= 1) or (DeathRunesNext() >= 1 and (BloodRunesNext() >= 1 and FrostRunesNext() >= 1) or (BloodRunesNext() >= 1 and UnholyRunesNext() >= 1) or (FrostRunesNext() >= 1 and UnholyRunesNext() >= 1)) or (DeathRunesNext() >= 2 and (BloodRunesNext() >= 1 or FrostRunesNext() >= 1 or UnholyRunesNext() >= 1)) or DeathRunesNext() >= 3
	end
	return self:cooldownNext() <= 0 and runesReady
end

function Ability:remains()
	if (self == FrostFever and currentTime - frostFeverCastTime < 1.1) or (self == BloodPlague and currentTime - bloodPlagueCastTime < 1.1) then
		return 21 + pointsInEpidemic * 4
	end
    return (select(7, UnitDebuff("target", self.name, nil, self.playerCastOnly and "PLAYER" or nil)) or currentTime) - currentTime - Zombie.latency
end

function Ability:remainsNext()
	local remaining = (select(7, UnitDebuff("target", self.name, nil, self.playerCastOnly and "PLAYER" or nil)) or currentTime) - currentTime - GCD - Zombie.latency
	if (self == FrostFever or self == BloodPlague) and abilityNow == FesteringStrike and remaining >= Zombie.latency then
		return remaining + 6
	elseif (self == FrostFever and (abilityNow == IcyTouch or abilityNow == Outbreak or (abilityNow == HowlingBlast and howlingBlastGlyphed) or currentTime - frostFeverCastTime < 1.1)) or (self == BloodPlague and (abilityNow == PlagueStrike or abilityNow == Outbreak or currentTime - bloodPlagueCastTime < 1.1)) then
		return 21 + pointsInEpidemic * 4
	end
	return remaining > 0 and remaining or 0
end

function Ability:up()
    return select(7, UnitBuff("player", self.name, nil, self.playerCastOnly and "PLAYER" or nil)) or 0 > Zombie.latency
end

function Ability:upNext()
	if (self == UnholyPresence and abilityNow == UnholyPresence) or (self == HornOfWinter and abilityNow == HornOfWinter) then
		return true
	elseif (self == SuddenDoom and abilityNow == DeathCoil) or (self == Rime and (abilityNow == IcyTouch or abilityNow == HowlingBlast)) or (self == KillingMachine and (abilityNow == Obliterate or abilityNow == FrostStrike)) then
		return false
	end
    return select(7, UnitBuff("player", self.name, nil, self.playerCastOnly and "PLAYER" or nil)) or 0 > GCD + Zombie.latency
end

function Ability:cooldown()
    local startTime, duration = GetSpellCooldown(self.spellId)
    return startTime > 0 and duration - (currentTime - startTime) - Zombie.latency or 0
end

function Ability:cooldownNext()
	local startTime, duration = GetSpellCooldown(self.spellId)
	if self == abilityNow and self.cooldownLength > DeathCoil:cooldown() then
		return self.cooldownLength
	end
    return startTime > 0 and duration - (currentTime - startTime) - GCD - Zombie.latency or 0
end

function Ability:known()
    return GetSpellBookItemInfo(self.name, "player") and true or false
end

local function RunicPower()
    return UnitPower("player", 6)
end

local function RunicPowerNext()
	local runicPowerAdd = 0
	if abilityNow == ChainsOfIce or abilityNow == HowlingBlast or abilityNow == IcyTouch or abilityNow == Obliterate then
		runicPowerAdd = pointsInChillOfTheGrave * 5
	elseif abiltiyNow == EmpowerRuneWeapon then
		runicPowerAdd = 25
	elseif abilityNow == HornOfWinter then
		runicPowerAdd = 10
	end
    return UnitPower("player", 6) + (abilityNow.runeCost[1] + abilityNow.runeCost[2] + abilityNow.runeCost[3]) * 10 - (select(4, GetSpellInfo(abilityNow.spellId)) or 0) + runicPowerAdd
end

local function TargetTimeToDie()
    local targetTimeToDie = UnitHealth("target") / ((targetHealthArray[1] - targetHealthArray[#targetHealthArray]) / 3) - Zombie.latency
    return targetTimeToDie >= 0 and targetTimeToDie or 600
end

local function TargetTimeToDieNext()
    return TargetTimeToDie() - GCD
end

local function TimeInCombat()
    return currentTime - (combatStartTime > 0 and combatStartTime or currentTime) + Zombie.latency
end

local function TimeInCombatNext()
    return TimeInCombat() + GCD
end

local function TargetIsBoss()
	return Zombie.boss or UnitLevel("target") == -1 or (UnitLevel("target") >= UnitLevel("player") + 2 and not UnitInRaid("player"))
end

local function PlayerHasPet()
    return UnitName("pet") and true or false
end

local function PlayerHasPetNext()
    return UnitName("pet") or abilityNow == RaiseDead
end

local function ShadowInfusionStacks()
    return select(4, UnitBuff("pet", "Shadow Infusion")) or 0
end

local function ShadowInfusionStacksNext()
    return (select(4, UnitBuff("pet", "Shadow Infusion")) or 0) + (abilityNow == DeathCoil and 1 or 0) + (abilityNow == DarkTransformation and -5 or 0)
end

local function SpeedBuffActive()
	return UnholyFrenzy:up() or AncientHysteria:up() or Bloodlust:up() or Heroism:up() or TimeWarp:up()
end

local function SpeedBuffActiveNext()
	return UnholyFrenzy:upNext() or AncientHysteria:upNext() or Bloodlust:upNext() or Heroism:upNext() or TimeWarp:upNext() or abilityNow == UnholyFrenzy
end

function CalculateBestChoiceAbilityFrost()
    if UnholyPresence:ready() and not (UnholyPresence:up() or FrostPresence:up()) then
        return UnholyPresence
    elseif HornOfWinter:ready() and not (HornOfWinter:up() or BattleShout:up()) then
        return HornOfWinter
    elseif ArmyOfTheDead:known() and ArmyOfTheDead:ready() and Zombie.army and TargetIsBoss() then
        return ArmyOfTheDead
    elseif PillarOfFrost:known() and Zombie.pillar and PillarOfFrost:ready() then
        return PillarOfFrost
    elseif Zombie.bloodtap and BloodTap:ready() and DeathRunes() == 0 and RuneCooldown(1) >= 3 then
        return BloodTap
    elseif RaiseDead:ready() and (Zombie.raisedead or TargetIsBoss()) and (TimeInCombat() >= 15 or RuneOfTheFallenCrusader:up()) then
        return RaiseDead
    elseif Outbreak:known() and Outbreak:ready() and (FrostFever:remains() <= 2 or BloodPlague:remains() <= 2) then
        return Outbreak
    elseif howlingBlastGlyphed and HowlingBlast:ready() and FrostFever:remains() <= 2 then
        return HowlingBlast
    elseif not howlingBlastGlyphed and IcyTouch:ready() and FrostFever:remains() <= 2 then
        return IcyTouch
    elseif PlagueStrike:ready() and BloodPlague:remains() <= 2 then
        return PlagueStrike
    elseif Obliterate:ready() and (FrostRunes() == 2 or UnholyRunes() == 2 or DeathRunes() == 2 or KillingMachine:up()) then
        return Obliterate
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:ready() and (Zombie.erw or TargetIsBoss()) and TargetTimeToDie() <= 120 and KillingMachine:up() then
        return EmpowerRuneWeapon
    elseif FrostStrike:ready() and RunicPower() >= 95 - (SpeedBuffActive() and 5 or 0) then
        return FrostStrike
    elseif HowlingBlast:ready() and (Rime:up() or (DeathRunes() + UnholyRunes() == 0 and not SpeedBuffActive())) then
        return HowlingBlast
    elseif Obliterate:ready() then
        return Obliterate
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:ready() and (Zombie.erw or TargetIsBoss()) and TargetTimeToDie() <= 45 then
        return EmpowerRuneWeapon
    elseif FrostStrike:ready() and RunicPower() >= 40 - (frostStrikeGlyphed and 8 or 0) then
        return FrostStrike
    elseif HowlingBlast:ready() then
        return HowlingBlast
    elseif Zombie.bloodtap and BloodTap:ready() then
        return BloodTap
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:ready() and (Zombie.erw or TargetIsBoss()) then
        return EmpowerRuneWeapon
    elseif HornOfWinter:ready() then
        return HornOfWinter
    else
        return NoSpell
    end
end

function CalculateNextBestChoiceAbilityFrost()
    if UnholyPresence:readyNext() and not (UnholyPresence:upNext() or FrostPresence:up()) then
        return UnholyPresence
    elseif HornOfWinter:readyNext() and not (HornOfWinter:upNext() or BattleShout:up()) then
        return HornOfWinter
    elseif ArmyOfTheDead:known() and ArmyOfTheDead:readyNext() and Zombie.army and TargetIsBoss() then
        return ArmyOfTheDead
    elseif PillarOfFrost:known() and Zombie.pillar and PillarOfFrost:readyNext() then
        return PillarOfFrost
    elseif Zombie.bloodtap and BloodTap:readyNext() and DeathRunesNext() == 0 and RuneCooldownNext(1) >= 3 then
        return BloodTap
    elseif RaiseDead:readyNext() and (Zombie.raisedead or TargetIsBoss()) and (TimeInCombatNext() >= 15 or RuneOfTheFallenCrusader:upNext()) then
        return RaiseDead
    elseif Outbreak:known() and Outbreak:readyNext() and (FrostFever:remainsNext() <= 2 or BloodPlague:remainsNext() <= 2) then
        return Outbreak
    elseif howlingBlastGlyphed and HowlingBlast:readyNext() and FrostFever:remainsNext() <= 2 then
        return HowlingBlast
    elseif not howlingBlastGlyphed and IcyTouch:readyNext() and FrostFever:remainsNext() <= 2 then
        return IcyTouch
    elseif PlagueStrike:readyNext() and BloodPlague:remainsNext() <= 2 then
        return PlagueStrike
    elseif Obliterate:readyNext() and (FrostRunesNext() == 2 or UnholyRunesNext() == 2 or DeathRunesNext() == 2 or KillingMachine:upNext()) then
        return Obliterate
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:readyNext() and (Zombie.erw or TargetIsBoss()) and TargetTimeToDieNext() <= 120 and KillingMachine:upNext() then
        return EmpowerRuneWeapon
    elseif FrostStrike:readyNext() and RunicPowerNext() >= 95 - (SpeedBuffActiveNext() and 5 or 0) then
        return FrostStrike
    elseif HowlingBlast:readyNext() and (Rime:upNext() or (DeathRunesNext() + UnholyRunesNext() == 0 and not SpeedBuffActiveNext())) then
        return HowlingBlast
    elseif Obliterate:readyNext() then
        return Obliterate
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:readyNext() and (Zombie.erw or TargetIsBoss()) and TargetTimeToDieNext() <= 45 then
        return EmpowerRuneWeapon
    elseif FrostStrike:readyNext() and RunicPowerNext() >= 40 - (frostStrikeGlyphed and 8 or 0) then
        return FrostStrike
    elseif HowlingBlast:readyNext() then
        return HowlingBlast
    elseif Zombie.bloodtap and BloodTap:readyNext() then
        return BloodTap
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:readyNext() and (Zombie.erw or TargetIsBoss()) then
        return EmpowerRuneWeapon
    elseif HornOfWinter:readyNext() then
        return HornOfWinter
    else
        return NoSpell
    end
end

function CalculateBestChoiceAbilityAoEFrost()
    if UnholyPresence:ready() and not (UnholyPresence:up() or FrostPresence:up()) then
        return UnholyPresence
    elseif HornOfWinter:ready() and not (HornOfWinter:up() or BattleShout:up()) then
        return HornOfWinter
    elseif PillarOfFrost:known() and Zombie.pillar and PillarOfFrost:ready() then
        return PillarOfFrost
    elseif Zombie.bloodtap and BloodTap:ready() and DeathRunes() == 0 and RuneCooldown(1) >= 3 then
        return BloodTap
    elseif HowlingBlast:ready() and FrostRunes() == 2 or DeathRunes() >= 2 then
        return HowlingBlast
	elseif DeathAndDecay:ready() and UnholyRunes() == 2 then
		return DeathAndDecay
    elseif PlagueStrike:ready() and UnholyRunes() == 2 and BloodPlague:remains() <= 2 then
        return PlagueStrike
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:ready() and (Zombie.erw or TargetIsBoss()) and TargetTimeToDie() <= 120 then
        return EmpowerRuneWeapon
    elseif FrostStrike:ready() and RunicPower() >= 95 - (SpeedBuffActive() and 5 or 0) then
        return FrostStrike
    elseif HowlingBlast:ready() and FrostRunes() >= 1 or DeathRunes() >= 1 then
        return HowlingBlast
	elseif DeathAndDecay:ready() and UnholyRunes() >= 1 then
		return DeathAndDecay
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:ready() and (Zombie.erw or TargetIsBoss()) and TargetTimeToDie() <= 45 then
        return EmpowerRuneWeapon
    elseif FrostStrike:ready() and RunicPower() >= 40 - (frostStrikeGlyphed and 8 or 0) then
        return FrostStrike
	elseif RaiseDead:ready() and (Zombie.raisedead or TargetIsBoss()) and (TimeInCombat() >= 15 or RuneOfTheFallenCrusader:up()) then
		return RaiseDead
    elseif PlagueStrike:ready() and UnholyRunes() >= 1 then
        return PlagueStrike
    elseif Zombie.bloodtap and BloodTap:ready() then
        return BloodTap
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:ready() and (Zombie.erw or TargetIsBoss()) then
        return EmpowerRuneWeapon
    elseif HornOfWinter:ready() then
        return HornOfWinter
    elseif Outbreak:known() and Outbreak:ready() and (FrostFever:remains() <= 2 or BloodPlague:remains() <= 2) then
        return Outbreak
	else
        return NoSpell
    end
end

function CalculateNextBestChoiceAbilityAoEFrost()
    if UnholyPresence:readyNext() and not (UnholyPresence:upNext() or FrostPresence:up()) then
        return UnholyPresence
    elseif HornOfWinter:readyNext() and not (HornOfWinter:upNext() or BattleShout:up()) then
        return HornOfWinter
    elseif PillarOfFrost:known() and Zombie.pillar and PillarOfFrost:readyNext() then
        return PillarOfFrost
    elseif Zombie.bloodtap and BloodTap:readyNext() and DeathRunesNext() == 0 and RuneCooldownNext(1) >= 3 then
        return BloodTap
    elseif HowlingBlast:readyNext() and FrostRunesNext() == 2 or DeathRunesNext() >= 2 then
        return HowlingBlast
	elseif DeathAndDecay:readyNext() and UnholyRunesNext() == 2 then
		return DeathAndDecay
    elseif PlagueStrike:readyNext() and UnholyRunesNext() == 2 and BloodPlague:remainsNext() <= 2 then
        return PlagueStrike
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:readyNext() and (Zombie.erw or TargetIsBoss()) and TargetTimeToDieNext() <= 120 then
        return EmpowerRuneWeapon
    elseif FrostStrike:readyNext() and RunicPowerNext() >= 95 - (SpeedBuffActiveNext() and 5 or 0) then
        return FrostStrike
    elseif HowlingBlast:readyNext() and FrostRunesNext() >= 1 or DeathRunesNext() >= 1 then
        return HowlingBlast
	elseif DeathAndDecay:readyNext() and UnholyRunesNext() >= 1 then
		return DeathAndDecay
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:readyNext() and (Zombie.erw or TargetIsBoss()) and TargetTimeToDieNext() <= 45 then
        return EmpowerRuneWeapon
    elseif FrostStrike:readyNext() and RunicPowerNext() >= 40 - (frostStrikeGlyphed and 8 or 0) then
        return FrostStrike
	elseif RaiseDead:readyNext() and (Zombie.raisedead or TargetIsBoss()) and (TimeInCombatNext() >= 15 or RuneOfTheFallenCrusader:upNext()) then
		return RaiseDead
    elseif PlagueStrike:readyNext() and UnholyRunesNext() >= 1 then
        return PlagueStrike
    elseif Zombie.bloodtap and BloodTap:readyNext() then
        return BloodTap
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:readyNext() and (Zombie.erw or TargetIsBoss()) then
        return EmpowerRuneWeapon
    elseif HornOfWinter:readyNext() then
        return HornOfWinter
    elseif Outbreak:known() and Outbreak:readyNext() and (FrostFever:remainsNext() <= 2 or BloodPlague:remainsNext() <= 2) then
        return Outbreak
	else
        return NoSpell
    end
end

function CalculateBestChoiceAbilityUnholy()
    if UnholyPresence:ready() and not (UnholyPresence:up() or FrostPresence:up()) then
        return UnholyPresence
    elseif HornOfWinter:ready() and not (HornOfWinter:up() or BattleShout:up()) then
        return HornOfWinter
    elseif ArmyOfTheDead:known() and ArmyOfTheDead:ready() and Zombie.army and TargetIsBoss() then
        return ArmyOfTheDead
    elseif RaiseDead:ready() and not PlayerHasPet() then
        return RaiseDead
    elseif UnholyFrenzy:known() and UnholyFrenzy:ready() and (TargetTimeToDie() <= 45 or not SpeedBuffActive()) then
        return UnholyFrenzy
    elseif Outbreak:known() and Outbreak:ready() and (FrostFever:remains() <= 2 or BloodPlague:remains() <= 2) then
        return Outbreak
    elseif IcyTouch:ready() and FrostFever:remains() < 3 then
        return IcyTouch
    elseif PlagueStrike:ready() and BloodPlague:remains() < 3 then
        return PlagueStrike
    elseif DarkTransformation:known() and DarkTransformation:ready() and ShadowInfusionStacks() == 5 then
        return DarkTransformation
    elseif SummonGargoyle:ready() and (Zombie.gargoyle or TargetIsBoss()) and RunicPower() >= 60 and (TimeInCombat() <= 60 or SpeedBuffActive()) then
        return SummonGargoyle
    elseif DeathAndDecay:ready() and (DeathRunes() == 4 or UnholyRunes() == 2) then
        return DeathAndDecay
    elseif ScourgeStrike:ready() and (DeathRunes() == 4 or UnholyRunes() == 2) then
        return ScourgeStrike
    elseif FesteringStrike:ready() and BloodRunes() + FrostRunes() == 4 then
        return FesteringStrike
    elseif DeathCoil:ready() and (RunicPower() > 90 or SuddenDoom:up()) then
        return DeathCoil
    elseif DeathAndDecay:ready() then
        return DeathAndDecay
    elseif ScourgeStrike:ready() then
        return ScourgeStrike
    elseif FesteringStrike:ready() then
        return FesteringStrike
    elseif DeathCoil:ready() and RunicPower() >= 34 then
        return DeathCoil
    elseif Zombie.bloodtap and BloodTap:ready() and UnholyRunes() == 0 and DeathRunes() <= 3 then
        return BloodTap
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:ready() and Zombie.erw and UnholyRunes() == 0 then
        return EmpowerRuneWeapon
    elseif HornOfWinter:ready() then
        return HornOfWinter
    else
        return NoSpell
    end
end

function CalculateNextBestChoiceAbilityUnholy()
    if UnholyPresence:readyNext() and not (UnholyPresence:upNext() or FrostPresence:up()) then
        return UnholyPresence
    elseif HornOfWinter:readyNext() and not (HornOfWinter:upNext() or BattleShout:up()) then
        return HornOfWinter
    elseif ArmyOfTheDead:known() and ArmyOfTheDead:readyNext() and Zombie.army and TargetIsBoss() then
        return ArmyOfTheDead
    elseif RaiseDead:readyNext() and not PlayerHasPetNext() then
        return RaiseDead
    elseif UnholyFrenzy:known() and UnholyFrenzy:readyNext() and (TargetTimeToDieNext() <= 45 or not SpeedBuffActiveNext()) then
        return UnholyFrenzy
    elseif Outbreak:known() and Outbreak:readyNext() and (FrostFever:remainsNext() <= 2 or BloodPlague:remainsNext() <= 2) then
        return Outbreak
    elseif IcyTouch:readyNext() and FrostFever:remainsNext() < 3 then
        return IcyTouch
    elseif PlagueStrike:readyNext() and BloodPlague:remainsNext() < 3 then
        return PlagueStrike
    elseif DarkTransformation:known() and DarkTransformation:readyNext() and ShadowInfusionStacksNext() == 5 then
        return DarkTransformation
    elseif SummonGargoyle:readyNext() and (Zombie.gargoyle or TargetIsBoss()) and RunicPowerNext() >= 60 and (TimeInCombatNext() <= 60 or SpeedBuffActiveNext()) then
        return SummonGargoyle
    elseif DeathAndDecay:readyNext() and (DeathRunesNext() == 4 or UnholyRunesNext() == 2) then
        return DeathAndDecay
    elseif ScourgeStrike:readyNext() and (DeathRunesNext() == 4 or UnholyRunesNext() == 2) then
        return ScourgeStrike
    elseif FesteringStrike:readyNext() and BloodRunesNext() + FrostRunesNext() == 4 then
        return FesteringStrike
    elseif DeathCoil:readyNext() and (RunicPowerNext() > 90 or SuddenDoom:upNext()) then
        return DeathCoil
    elseif DeathAndDecay:readyNext() then
        return DeathAndDecay
    elseif ScourgeStrike:readyNext() then
        return ScourgeStrike
    elseif FesteringStrike:readyNext() then
        return FesteringStrike
    elseif DeathCoil:readyNext() and RunicPowerNext() >= 34 then
        return DeathCoil
    elseif Zombie.bloodtap and BloodTap:readyNext() and UnholyRunesNext() == 0 and DeathRunesNext() <= 3 then
        return BloodTap
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:readyNext() and Zombie.erw and UnholyRunesNext() == 0 then
        return EmpowerRuneWeapon
    elseif HornOfWinter:readyNext() then
        return HornOfWinter
    else
        return NoSpell
    end
end

function CalculateBestChoiceAbilityAoEUnholy()
    if UnholyPresence:ready() and not (UnholyPresence:up() or FrostPresence:up()) then
        return UnholyPresence
    elseif HornOfWinter:ready() and not (HornOfWinter:up() or BattleShout:up()) then
        return HornOfWinter
    elseif RaiseDead:ready() and not PlayerHasPet() then
        return RaiseDead
    elseif UnholyFrenzy:known() and UnholyFrenzy:ready() and (TargetTimeToDie() <= 45 or not SpeedBuffActive()) then
        return UnholyFrenzy
    elseif Outbreak:known() and Outbreak:ready() and (FrostFever:remains() <= 2 or BloodPlague:remains() <= 2) then
        return Outbreak
    elseif IcyTouch:ready() and FrostFever:remains() < 3 then
        return IcyTouch
    elseif PlagueStrike:ready() and BloodPlague:remains() < 3 then
        return PlagueStrike
    elseif DarkTransformation:known() and DarkTransformation:ready() and ShadowInfusionStacks() == 5 then
        return DarkTransformation
    elseif DeathAndDecay:ready() and (DeathRunes() == 4 or UnholyRunes() == 2) then
        return DeathAndDecay
    elseif ScourgeStrike:ready() and (DeathRunes() == 4 or UnholyRunes() == 2) then
        return ScourgeStrike
    elseif BloodBoil:ready() and BloodRunes() + FrostRunes() == 4 then
        return BloodBoil
    elseif SummonGargoyle:ready() and (Zombie.gargoyle or TargetIsBoss()) and RunicPower() >= 60 and (TimeInCombat() <= 60 or SpeedBuffActive()) then
        return SummonGargoyle
    elseif DeathCoil:ready() and (RunicPower() > 90 or SuddenDoom:up()) then
        return DeathCoil
    elseif DeathAndDecay:ready() then
        return DeathAndDecay
    elseif ScourgeStrike:ready() then
        return ScourgeStrike
    elseif BloodBoil:ready() then
        return BloodBoil
    elseif DeathCoil:ready() and RunicPower() >= 34 then
        return DeathCoil
    elseif Zombie.bloodtap and BloodTap:ready() and UnholyRunes() == 0 and DeathRunes() <= 3 then
        return BloodTap
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:ready() and (Zombie.erw or TargetIsBoss) and UnholyRunes() == 0 then
        return EmpowerRuneWeapon
    elseif IcyTouch:ready() then
        return IcyTouch
    elseif HornOfWinter:ready() then
        return HornOfWinter
    else
        return NoSpell
    end
end

function CalculateNextBestChoiceAbilityAoEUnholy()
    if UnholyPresence:readyNext() and not (UnholyPresence:upNext() or FrostPresence:up()) then
        return UnholyPresence
    elseif HornOfWinter:readyNext() and not (HornOfWinter:upNext() or BattleShout:up()) then
        return HornOfWinter
    elseif RaiseDead:readyNext() and not PlayerHasPetNext() then
        return RaiseDead
    elseif UnholyFrenzy:known() and UnholyFrenzy:readyNext() and (TargetTimeToDieNext() <= 45 or not SpeedBuffActiveNext()) then
        return UnholyFrenzy
    elseif Outbreak:known() and Outbreak:readyNext() and (FrostFever:remainsNext() <= 2 or BloodPlague:remainsNext() <= 2) then
        return Outbreak
    elseif IcyTouch:readyNext() and FrostFever:remainsNext() < 3 then
        return IcyTouch
    elseif PlagueStrike:readyNext() and BloodPlague:remainsNext() < 3 then
        return PlagueStrike
    elseif DarkTransformation:known() and DarkTransformation:readyNext() and ShadowInfusionStacksNext() == 5 then
        return DarkTransformation
    elseif DeathAndDecay:readyNext() and (DeathRunesNext() == 4 or UnholyRunesNext() == 2) then
        return DeathAndDecay
    elseif ScourgeStrike:readyNext() and (DeathRunesNext() == 4 or UnholyRunesNext() == 2) then
        return ScourgeStrike
    elseif BloodBoil:readyNext() and BloodRunesNext() + FrostRunesNext() == 4 then
        return BloodBoil
    elseif SummonGargoyle:readyNext() and (Zombie.gargoyle or TargetIsBoss()) and RunicPowerNext() >= 60 and (TimeInCombatNext() <= 60 or SpeedBuffActiveNext()) then
        return SummonGargoyle
    elseif DeathCoil:readyNext() and (RunicPowerNext() > 90 or SuddenDoom:upNext()) then
        return DeathCoil
    elseif DeathAndDecay:readyNext() then
        return DeathAndDecay
    elseif ScourgeStrike:readyNext() then
        return ScourgeStrike
    elseif BloodBoil:readyNext() then
        return BloodBoil
    elseif DeathCoil:readyNext() and RunicPowerNext() >= 34 then
        return DeathCoil
    elseif Zombie.bloodtap and BloodTap:readyNext() and UnholyRunesNext() == 0 and DeathRunesNext() <= 3 then
        return BloodTap
    elseif EmpowerRuneWeapon:known() and EmpowerRuneWeapon:readyNext() and (Zombie.erw or TargetIsBoss) and UnholyRunesNext() == 0 then
        return EmpowerRuneWeapon
    elseif IcyTouch:readyNext() then
        return IcyTouch
    elseif HornOfWinter:readyNext() then
        return HornOfWinter
    else
        return NoSpell
    end
end

local function UpdateVars()
	GCD = 1.5 - 1.5 * (GetCombatRatingBonus(20) * 0.01) - (UnholyPresence:up() and 0.5 or 0)
	currentTime = GetTime()
end

local function SearchActionBarsBlizzard(actionBar)
	local actionButtons, actionType, spellIdOrMacro = {actionBar:GetChildren()}
	for i = 1, #actionButtons do
		if actionButtons[i].action then
			actionType, spellIdOrMacro = GetActionInfo(actionButtons[i].action)
			if actionType then
				for j = 1, #abilityList do
					if (actionType == "spell" and spellIdOrMacro == abilityList[j].spellId) or (actionType == "macro" and (select(2, GetMacroInfo(spellIdOrMacro))) == abilityList[j].icon) then
						abilityList[j].actionButton = actionButtons[i]
					end
				end
			end
		end
	end
end

local function SearchActionBarsBartender()
	local actionButtons, actionType, spellIdOrMacro
	for _, actionBar in Bartender4:GetModule("ActionBars"):GetAll() do
		for i = 1, actionBar:GetButtons() do
			actionType, spellIdOrMacro = GetActionInfo(actionBar.buttons[i]._state_action)
			if actionType then
				for j = 1, #abilityList do
					if (actionType == "spell" and spellIdOrMacro == abilityList[j].spellId) or (actionType == "macro" and (select(2, GetMacroInfo(spellIdOrMacro))) == abilityList[j].icon) then
						abilityList[j].actionButton = actionBar.buttons[i]
					end
				end
			end
		end
	end
end

local function SearchActionBarsDominos()
	local actionButtons, actionType, spellIdOrMacro
	for _, actionBar in Dominos.Frame:GetAll() do
		if actionBar.buttons then
			for _, button in pairs(actionBar.buttons) do
				if button:GetAttribute('action--base') then
					actionType, spellIdOrMacro = GetActionInfo(button:GetAttribute('action--base'))
					for j = 1, #abilityList do
						if (actionType == "spell" and spellIdOrMacro == abilityList[j].spellId) or (actionType == "macro" and (select(2, GetMacroInfo(spellIdOrMacro))) == abilityList[j].icon) then
							abilityList[j].actionButton = button
						end
					end
				end
			end
		end
	end
end

function events:PLAYER_TARGET_CHANGED()
	hostileTargetted = not UnitCanAttack("player", "target")
end

function events:ACTIONBAR_SHOWGRID()
	actionButtonMoved = true
end

function events:ACTIONBAR_HIDEGRID()
	actionButtonMoved = true
end

function events:ACTIONBAR_PAGE_CHANGED()
	actionButtonMoved = true
	events:ACTIONBAR_SLOT_CHANGED()
end

function events:ACTIONBAR_SLOT_CHANGED()
	if actionButtonMoved then
		for i = 1, #abilityList do
			abilityList[i].actionButton = nil
		end
		if Bartender4 then
			SearchActionBarsBartender()
		elseif Dominos then
			SearchActionBarsDominos()
		else
			SearchActionBarsBlizzard(MainMenuBarArtFrame)
			SearchActionBarsBlizzard(MultiBarLeft)
			SearchActionBarsBlizzard(MultiBarRight)
			SearchActionBarsBlizzard(MultiBarBottomLeft)
			SearchActionBarsBlizzard(MultiBarBottomRight)
		end
		actionButtonMoved = false
	end
end

function events:ACTIVE_TALENT_GROUP_CHANGED()
	howlingBlastGlyphed, frostStrikeGlyphed = false, false
	for i = 1, GetNumGlyphSockets() do
		if select(4, GetGlyphSocketInfo(i)) == 63335 then
			howlingBlastGlyphed = true
		elseif select(4, GetGlyphSocketInfo(i)) == 58647 then
			frostStrikeGlyphed = true
		end
	end
	pointsInEpidemic = select(5, GetTalentInfo(3, 3))
	pointsInChillOfTheGrave = select(5, GetTalentInfo(2, 9))
	actionButtonMoved = true
	events:ACTIONBAR_SLOT_CHANGED()
end

function events:PLAYER_REGEN_DISABLED()
    combatStartTime = GetTime()
end

function events:PLAYER_REGEN_ENABLED()
    combatStartTime, aoeStartTime, aoeMode = 0, 0, false
	wipe(aoeTargets)
end

function events:PLAYER_ENTERING_WORLD()
	events:ACTIVE_TALENT_GROUP_CHANGED()
end

function events:UNIT_SPELLCAST_SENT(srcName, spellName)
	if srcName == "player" and spellName == abilityNow.name then
		abilityPrevious = abilityNow
	end
end

function events:ADDON_LOADED(name)
	if name == "Zombie" then
		if not Zombie.scale then
			print("It looks like this is your first time running Zombie, why don't you take some time to familiarize yourself with the commands?")
			print("Type |cFFFFD000/zombie|r for a list of commands.")
		end
		InitializeVariables()
		zombiePanel:SetSize(64, 64)
		zombieNextPanel:SetSize(42, 42)
		zombiePreviousPanel:SetSize(42, 42)
		zombiePanel:SetScale(Zombie.scale)
		zombieNextPanel:SetScale(Zombie.scale)
		zombiePreviousPanel:SetScale(Zombie.scale)
		zombiePanel:EnableMouse(not Zombie.locked)
		zombieNextPanel:EnableMouse(not Zombie.locked)
		zombiePreviousPanel:EnableMouse(not Zombie.locked)
        for i = 1, math.floor(3 / Zombie.frequency) do targetHealthArray[i] = 0 end
		zombiePanel:Show()
	end
end

zombiePanel:SetScript("OnUpdate", function(self, elapsed)
    lastAbilityCalculation = lastAbilityCalculation + elapsed;
    if lastAbilityCalculation >= Zombie.frequency then
		if aoeStartTime ~= 0 and currentTime - aoeStartTime >= 1 then
			aoeMode, aoeStartTime = false, 0
			wipe(aoeTargets)
		end
		if aoeMode and Zombie.aoelabel then
			zombiePanel.aoelabel:Show()
		else
			zombiePanel.aoelabel:Hide()
		end
		if UnitCanAttack("player", "target") and not UnitInVehicle("player") then
			if not hostileTargetted then
				zombiePanel:EnableMouse(not Zombie.locked)
				zombieNextPanel:Show()
				zombiePreviousPanel:Hide()
				for i = 1, #targetHealthArray do targetHealthArray[i] = UnitHealth("target") end
				hostileTargetted = true
			else
				targetHealthArray[#targetHealthArray + 1] = UnitHealth("target")
				table.remove(targetHealthArray, 1)
			end
			oldAbilityNow, oldAbilityNext = abilityNow, abilityNext
			UpdateVars()
			if FrostStrike:known() then
				abilityNow = aoeMode and CalculateBestChoiceAbilityAoEFrost() or CalculateBestChoiceAbilityFrost()
				abilityNext = aoeMode and CalculateNextBestChoiceAbilityAoEFrost() or CalculateNextBestChoiceAbilityFrost()
			elseif ScourgeStrike:known() then
				abilityNow = aoeMode and CalculateBestChoiceAbilityAoEUnholy() or CalculateBestChoiceAbilityUnholy()
				abilityNext = aoeMode and CalculateNextBestChoiceAbilityAoEUnholy() or CalculateNextBestChoiceAbilityUnholy()
			else
				abilityNow, abilityNext = NoSpell, NoSpell
			end
			if Zombie.glow and abilityNow.actionButton then ActionButton_ShowOverlayGlow(abilityNow.actionButton) end
			if abilityNow ~= oldAbilityNow then
				zombiePanel.icon:SetTexture(abilityNow.icon)
				if abilityNow.icon then
					zombiePanel.icon:Show()
					zombiePanel.border:Show()
				else
					zombiePanel.icon:Hide()
					zombiePanel.border:Hide()
				end
				if Zombie.glow and oldAbilityNow.actionButton then ActionButton_HideOverlayGlow(oldAbilityNow.actionButton) end
			end
			if abilityNext ~= oldAbilityNext then
				if abilityNext.icon then
					zombieNextPanel.icon:Show()
					zombieNextPanel.border:Show()
				else
					zombieNextPanel.icon:Hide()
					zombieNextPanel.border:Hide()
				end
				zombieNextPanel.icon:SetTexture(abilityNext.icon)
			end
		elseif hostileTargetted then
			if Zombie.glow and abilityNow.actionButton then ActionButton_HideOverlayGlow(abilityNow.actionButton) end
			abilityNow, abilityNext = NoSpell, NoSpell
			zombiePanel.icon:Hide()
			zombiePanel.border:Hide()
			zombiePanel:EnableMouse(false)
			zombieNextPanel:Hide()
			zombiePreviousPanel:Hide()
			for i = 1, #targetHealthArray do targetHealthArray[i] = 0 end
			hostileTargetted = false
		end
        lastAbilityCalculation = 0
    end
end)

function events:COMBAT_LOG_EVENT_UNFILTERED(self, eventType, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlags, dstGUID, dstName, dstFlags, dstRaidFlags, spellId, ...)
	if (eventType == "SPELL_CAST_SUCCESS") and srcGUID == UnitGUID("player") and spellId == abilityPrevious.spellId then
		zombiePreviousPanel.icon:SetTexture(abilityPrevious.icon)
		zombiePreviousPanel.border:SetTexture("Interface\\AddOns\\Zombie\\border.blp")
		zombiePreviousPanel:Show()
	elseif Zombie.misseffect and eventType == "SPELL_MISSED" and srcGUID == UnitGUID("player") and spellId == abilityPrevious.spellId then
		zombiePreviousPanel.border:SetTexture("Interface\\AddOns\\Zombie\\misseffect.blp")
	end
	if eventType == "SPELL_CAST_SUCCESS" and srcGUID == UnitGUID("player") then
		if (spellId == HowlingBlast.spellId and howlingBlastGlyphed) or spellId == Outbreak.spellId then
			frostFeverCastTime = currentTime
		end
		if spellId == PlagueStrike.spellId or spellId == Outbreak.spellId then
			bloodPlagueCastTime = currentTime
		end
	elseif eventType == "SPELL_MISSED" and srcGUID == UnitGUID("player") then
		if (spellId == HowlingBlast.spellId and howlingBlastGlyphed) or spellId == Outbreak.spellId then
			frostFeverCastTime = 0
		end
		if spellId == PlagueStrike.spellId or spellId == Outbreak.spellId then
			bloodPlagueCastTime = 0
		end
	end
	if srcGUID == UnitGUID("player") and dstGUID ~= UnitGUID("player") and Zombie.aoe > 0 then
		if (spellId == HowlingBlast.spellId or spellId == DeathAndDecay.spellId or spellId == BloodBoil.spellId or spellId == Pestilence.spellId) then
			if eventType == "SPELL_CAST_SUCCESS" and aoeStartTime == 0 then
				aoeStartTime = currentTime
			elseif (eventType == "SPELL_DAMAGE" or eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_MISSED") and currentTime - aoeStartTime < 1 and not tContains(aoeTargets, dstGUID) then
				aoeTargets[#aoeTargets + 1] = dstGUID
				if #aoeTargets >= Zombie.aoe then
					aoeMode, aoeStartTime = true, 0
					wipe(aoeTargets)
				end
			end
		end
		if aoeMode and (spellId == Obliterate.spellId or spellId == FesteringStrike.spellId) then
			aoeMode, aoeStartTime = false, 0
			wipe(aoeTargets)
		end
	end
end

zombiePanel:SetScript("OnEvent", function(self, event, ...) events[event](self, ...) end)
for k, _ in pairs(events) do
    zombiePanel:RegisterEvent(k)
end

function SlashCmdList.Zombie(msg, editbox)
    msg = {strsplit(" ", strlower(msg))}
    if msg[1] == "locked" then
        if msg[2] then
			Zombie.locked = msg[2] == "on" 
			zombiePanel:EnableMouse(not Zombie.locked and zombiePanel.icon:IsVisible())
			zombieNextPanel:EnableMouse(not Zombie.locked)
			zombiePreviousPanel:EnableMouse(not Zombie.locked)
		end
        print("Zombie - Locked: " .. (Zombie.locked and "|cFF00C000On" or "|cFFC00000Off"))
    elseif msg[1] == "glow" then
        if msg[2] then
			Zombie.glow = msg[2] == "on"
			if Zombie.glow then
				if abilityNow.actionButton then ActionButton_ShowOverlayGlow(abilityNow.actionButton) end
			else
				if abilityNow.actionButton then ActionButton_HideOverlayGlow(abilityNow.actionButton) end
			end
		end
        print("Zombie - Glowing ability buttons: " .. (Zombie.glow and "|cFF00C000On" or "|cFFC00000Off"))
    elseif msg[1] == "scale" then
        if msg[2] then
			Zombie.scale = tonumber(msg[2]) or 1
			zombiePanel:SetScale(Zombie.scale)
			zombieNextPanel:SetScale(Zombie.scale)
			zombiePreviousPanel:SetScale(Zombie.scale)
		end
        print("Zombie - Scale: |cFFFFD000" .. Zombie.scale .. "|r times")
    elseif msg[1] == "frequency" then
        if msg[2] then
			Zombie.frequency = tonumber(msg[2]) or 0.05
			wipe(targetHealthArray)
			for i = 1, math.floor(3 / Zombie.frequency) do targetHealthArray[i] = 0 end
		end
        print("Zombie - Calculation frequency: |cFFFFD000" .. Zombie.frequency .. "|r seconds")
    elseif msg[1] == "latency" then
        if msg[2] then Zombie.latency = tonumber(msg[2]) or 0.3 end
        print("Zombie - Player reaction time: |cFFFFD000" .. Zombie.latency .. "|r seconds")
    elseif msg[1] == "defaults" then
        zombiePanel:SetPoint("CENTER", 0, -155)
		zombieNextPanel:SetPoint("BOTTOMLEFT", zombiePanel, "BOTTOMRIGHT", 10, -5)
		zombiePreviousPanel:SetPoint("BOTTOMRIGHT", zombiePanel, "BOTTOMLEFT", -10, -5)
		wipe(Zombie)
		InitializeVariables()
		print("Zombie - |cFFC00000All settings reset to defaults")
    elseif msg[1] == "reset" then
        zombiePanel:SetPoint("CENTER", 0, -155)
		zombieNextPanel:SetPoint("BOTTOMLEFT", zombiePanel, "BOTTOMRIGHT", 10, -5)
		zombiePreviousPanel:SetPoint("BOTTOMRIGHT", zombiePanel, "BOTTOMLEFT", -10, -5)
		print("Zombie - Position reset")
    elseif msg[1] == "boss" then
        if msg[2] then Zombie.boss = msg[2] == "on" end
        print("Zombie - Everything is a boss: " .. (Zombie.boss and "|cFF00C000On" or "|cFFC00000Off"))
	elseif msg[1] == "misseffect" then
        if msg[2] then Zombie.misseffect = msg[2] == "on" end
        print("Zombie - Red border around previous ability when it fails to hit: " .. (Zombie.misseffect and "|cFF00C000On" or "|cFFC00000Off"))
	elseif msg[1] == "aoe" then
        if msg[2] then Zombie.aoe = tonumber(msg[2]) and (tonumber(msg[2]) < 0 and 0 or tonumber(msg[2])) or 3 end
        print("Zombie - Activate AoE mode on: " .. (Zombie.aoe > 0 and "|cFFFFD000" .. Zombie.aoe .. "|r targets" or "|cFFC00000Never"))
    elseif msg[1] == "aoelabel" then
        if msg[2] then Zombie.aoelabel = msg[2] == "on" end
        print("Zombie - Diplay 'AoE mode on' label: " .. (Zombie.aoelabel and "|cFF00C000On" or "|cFFC00000Off"))
    elseif msg[1] == "army" then
        if msg[2] then Zombie.army = msg[2] == "on" end
        print("Zombie - Army of the Dead: " .. (Zombie.army and "|cFF00C000On" or "|cFFC00000Off"))
    elseif msg[1] == "bloodtap" then
        if msg[2] then Zombie.bloodtap = msg[2] == "on" end
        print("Zombie - Blood Tap: " .. (Zombie.bloodtap and "|cFF00C000On" or "|cFFC00000Off"))
    elseif msg[1] == "erw" then
        if msg[2] then Zombie.erw = msg[2] == "on" end
        print("Zombie - Empower Rune Weapon on non-bosses: " .. (Zombie.erw and "|cFF00C000On" or "|cFFC00000Off"))
    elseif msg[1] == "gargoyle" then
        if msg[2] then Zombie.gargoyle = msg[2] == "on" end
        print("Zombie - Summon Gargoyle on non-bosses: " .. (Zombie.gargoyle and "|cFF00C000On" or "|cFFC00000Off"))
    elseif msg[1] == "pillar" then
        if msg[2] then Zombie.pillar = msg[2] == "on" end
        print("Zombie - Pillar of Frost: " .. (Zombie.pillar and "|cFF00C000On" or "|cFFC00000Off"))
    elseif msg[1] == "raisedead" then
        if msg[2] then Zombie.raisedead = msg[2] == "on" end
        print("Zombie - Raise Dead on non-bosses: " .. (Zombie.raisedead and "|cFF00C000On" or "|cFFC00000Off"))
    else
        print("Zombie (version: |cFFFFD000" .. GetAddOnMetadata("Zombie", "Version") .. "|r) - Commands:")
        print("  /zombie locked |cFF00C000on|r/|cFFC00000off|r - lock the Zombie UI so that it can't be moved")
		print("  /zombie glow |cFF00C000on|r/|cFFC00000off|r - enable glowing ability buttons on action bars")
        print("  /zombie scale |cFFFFD000[number]|r - set the scale of the Zombie UI (default is 1.0 times)")
        print("  /zombie frequency |cFFFFD000[number]|r - set the calculation frequency (default is 0.05 seconds)")
        print("  /zombie latency |cFFFFD000[number]|r - set the latency of the player's reaction time (default is 0.3 seconds)")
		print("  /zombie defaults - reset all Zombie settings to the defaults")
        print("  /zombie reset - reset the location of the Zombie UI to default")
		print("  /zombie boss |cFF00C000on|r/|cFFC00000off|r - treat every target as a boss mob")
		print("  /zombie misseffect |cFF00C000on|r/|cFFC00000off|r - enable red border around previous ability when it fails to hit")
		print("  /zombie aoe |cFFFFD000[number]|r - set the number of targets that have to be hit at once for AoE mode to trigger (0 = never, default is 3 targets)")
		print("  /zombie aoelabel |cFFFFD000[number]|r - display a label on the best choice ability icon denoting AoE mode is on")
        print("  /zombie army |cFF00C000on|r/|cFFC00000off|r - enable usage of Army of the Dead (bosses only)")
		print("  /zombie bloodtap |cFF00C000on|r/|cFFC00000off|r - enable usage of Blood Tap (turn off if you'd like to manage it for certain situations)")
        print("  /zombie erw |cFF00C000on|r/|cFFC00000off|r - enable usage of Empower Rune Weapon on non-bosses")
        print("  /zombie gargoyle |cFF00C000on|r/|cFFC00000off|r - enable usage of Summon Gargoyle on non-bosses")
        print("  /zombie pillar |cFF00C000on|r/|cFFC00000off|r - enable usage of Pillar of Frost (turn off if macro'd into abilities)")
        print("  /zombie raisedead |cFF00C000on|r/|cFFC00000off|r - enable usage of Raise Dead on non-bosses (frost only)")
		if Zombie_Resources then
			print("For Zombie Resources commands, please type |cFFFFD000/zres|r.")
		end
    end
end
