Zombie_Resources = {
	runesOn = true,
	runicPowerOn = true,
	gcdOn = true,
    hidden = false,
    locked = false,
	scale = 1,
    runeHeight = 12,
    runeWidth = 30,
	runicPowerHeight = 11,
	gcdBarHeight = 3
}

if select(2, UnitClass("player")) ~= "DEATHKNIGHT" then
    DisableAddOn("Zombie_Resources")
    return
end

SLASH_Zombie_Resources1, SLASH_Zombie_Resources2, SLASH_Zombie_Resources3 = "/zombieres", "/zombres", "/zres"

local events = {}
local lastOnUpdate = 0
local colors = {
	{0.6, 0, 0}, -- Blood
	{0, 0.6, 0}, -- Unholy
	{0, 0.4, 0.7}, -- Frost
	{0.6, 0, 0.6}, -- Death
	{0, 0.45, 0.55}, -- Runic Power
	{0, 0, 0, 0.8} -- Global Cooldown
}
local backDrop = {
    bgFile = "Interface\\Addons\\Zombie_Resources\\white16x16",
    edgeFile = "Interface\\Addons\\Zombie_Resources\\white16x16",
    edgeSize = 1,
    insets = {
        left = 1,
        right = 1,
        top = 1,
        bottom = 1
    },
    tile = true,
    tileSize = 16
}
local Zombie_ResourcesPanel = CreateFrame("Frame", "Zombie_ResourcesPanel", UIParent)
local runeCases = {}
local runes = {}
local runicPowerCase = CreateFrame("Frame", nil, Zombie_ResourcesPanel)
local runicPower = CreateFrame("Frame", nil, runicPowerCase)
local runicPowerText = runicPower:CreateFontString(nil, "OVERLAY")
local gcdBar = CreateFrame("Frame", nil, Zombie_ResourcesPanel)

local function SetVisibility()
	for i = 1, 6 do
		if Zombie_Resources.runesOn then
			runeCases[i]:Show()
		else
			runeCases[i]:Hide()
		end
	end
	if Zombie_Resources.runicPowerOn then
		runicPowerCase:Show()
		runicPowerText:Show()
	else
		runicPowerCase:Hide()
		runicPowerText:Hide()
	end
	if Zombie_Resources.gcdOn then
		gcdBar:Show()
	else
		gcdBar:Hide()
	end
end

function events:ADDON_LOADED(name)
	if name == "Zombie_Resources" then
		Zombie_ResourcesPanel:SetPoint("CENTER", UIParent, 0, -209)
		Zombie_ResourcesPanel:SetFrameStrata("BACKGROUND")
		Zombie_ResourcesPanel:SetWidth((Zombie_Resources.runeWidth + 2) * 6 - 2)
		Zombie_ResourcesPanel:SetHeight(Zombie_Resources.gcdBarHeight + Zombie_Resources.runeHeight + Zombie_Resources.runicPowerHeight + 6)
		Zombie_ResourcesPanel:SetScale(Zombie_Resources.scale)
		Zombie_ResourcesPanel:RegisterForDrag("LeftButton")
		Zombie_ResourcesPanel:SetScript("OnDragStart", Zombie_ResourcesPanel.StartMoving)
		Zombie_ResourcesPanel:SetScript("OnDragStop", Zombie_ResourcesPanel.StopMovingOrSizing)
		Zombie_ResourcesPanel:SetMovable(true)
		Zombie_ResourcesPanel:EnableMouse(not Zombie_Resources.locked)
		for i = 1, 6 do
			runeCases[i] = CreateFrame("Frame", nil, Zombie_ResourcesPanel)
			runeCases[i]:SetFrameStrata("BACKGROUND")
			runeCases[i]:SetWidth(Zombie_Resources.runeWidth)
			runeCases[i]:SetHeight(Zombie_Resources.runeHeight)
			runeCases[i]:SetPoint("TOPLEFT", Zombie_ResourcesPanel, "TOPLEFT", (i - 1) * (Zombie_Resources.runeWidth + 2), -Zombie_Resources.gcdBarHeight - 3)
			runeCases[i]:SetBackdrop(backDrop)
			runeCases[i]:SetBackdropBorderColor(0, 0, 0, 0.5)
		end
		for i = 1, 6 do
			runes[i] = CreateFrame("Frame", nil, runeCases[i + (i > 4 and -2 or i > 2 and 2 or 0)])
			runes[i]:SetFrameStrata("BACKGROUND")
			runes[i]:SetHeight(Zombie_Resources.runeHeight - 2)
			runes[i]:SetPoint("LEFT", runeCases[i + (i > 4 and -2 or i > 2 and 2 or 0)], "LEFT", 1, 0)
			runes[i]:SetBackdrop(backDrop)
		end
		runicPowerCase:SetFrameStrata("BACKGROUND")
		runicPowerCase:SetPoint("BOTTOM", Zombie_ResourcesPanel, "BOTTOM", 0, 1)
		runicPowerCase:SetWidth((Zombie_Resources.runeWidth + 2) * 6 - 2)
		runicPowerCase:SetHeight(Zombie_Resources.runicPowerHeight)
		runicPowerCase:SetBackdrop(backDrop)
		runicPowerCase:SetBackdropBorderColor(0, 0, 0, 0.5)
		runicPowerCase:SetBackdropColor(0, 0, 0, 0.8)
		runicPower:SetFrameStrata("BACKGROUND")
		runicPower:SetPoint("LEFT", runicPowerCase, "LEFT", 1, 0)
		runicPower:SetHeight(Zombie_Resources.runicPowerHeight - 2)
		runicPower:SetBackdrop(backDrop)
		runicPower:SetBackdropBorderColor(colors[5][1] + 0.1, colors[5][2] + 0.1, colors[5][3] + 0.1, 1)
		runicPower:SetBackdropColor(colors[5][1], colors[5][2], colors[5][3], 1)
		runicPowerText:SetFont("Fonts\\FRIZQT__.TTF", 8, "")
		runicPowerText:SetShadowOffset(1, -1)
		runicPowerText:SetShadowColor(0, 0, 0, 0.8)
		runicPowerText:SetPoint("CENTER", runicPowerCase)
		gcdBar:SetFrameStrata("BACKGROUND")
		gcdBar:SetPoint("TOPLEFT", Zombie_ResourcesPanel, "TOPLEFT", 0, -1)
		gcdBar:SetHeight(Zombie_Resources.gcdBarHeight)
		gcdBar:SetBackdrop(backDrop)
		gcdBar:SetBackdropColor(colors[6][1] + 0.05, colors[6][2] + 0.05, colors[6][3] + 0.05, colors[6][4])
		gcdBar:SetBackdropBorderColor(colors[6][1], colors[6][2], colors[6][3], colors[6][4])
		SetVisibility()
	end
end

Zombie_ResourcesPanel:SetScript("OnUpdate", function(self, elapsed)
    lastOnUpdate = lastOnUpdate + elapsed
    if lastOnUpdate >= 0.01 then
		if Zombie_Resources.runesOn then
			for i = 1, 6 do
				local runeStart, runeDuration, runeReady = GetRuneCooldown(i)
				local runeWidth = runeReady and Zombie_Resources.runeWidth - 2 or (GetTime() - runeStart) / runeDuration * (Zombie_Resources.runeWidth - 2)
				if runeWidth < 1 or UnitIsDeadOrGhost("player") then
					runes[i]:DisableDrawLayer("BACKGROUND")
					runes[i]:DisableDrawLayer("BORDER")
				else
					runes[i]:SetWidth(runeWidth)
					runes[i]:EnableDrawLayer("BACKGROUND")
					runes[i]:EnableDrawLayer("BORDER")
				end
				runes[i]:SetBackdropColor(colors[GetRuneType(i)][1], colors[GetRuneType(i)][2], colors[GetRuneType(i)][3], not runeReady and 0.5 or 1)
				runes[i]:SetBackdropBorderColor(colors[GetRuneType(i)][1] + 0.1, colors[GetRuneType(i)][2] + 0.1, colors[GetRuneType(i)][3] + 0.1, not runeReady and 0.5 or 1)
				runes[i]:GetParent():SetBackdropColor(colors[GetRuneType(i)][1] / 4, colors[GetRuneType(i)][2] / 4, colors[GetRuneType(i)][3] / 4, 0.8)
			end
		end
		if Zombie_Resources.runicPowerOn then
			if UnitPower("player") == 0 then
				runicPower:DisableDrawLayer("BACKGROUND")
				runicPower:DisableDrawLayer("BORDER")
			else
				runicPower:SetWidth(UnitPower("player") * ((Zombie_Resources.runeWidth + 2) * 6 - 4) / UnitPowerMax("player"))
				runicPower:EnableDrawLayer("BACKGROUND")
				runicPower:EnableDrawLayer("BORDER")
			end
			runicPowerText:SetText(UnitPower("player") .. "/" .. UnitPowerMax("player"))
		end
		if Zombie_Resources.gcdOn then
			local gcdStart, gcdDuration = GetSpellCooldown(47541)
			if gcdStart ~= 0 then
				gcdBar:SetWidth((Zombie_Resources.runeWidth + 2) * 6 - 2 - ((GetTime() - gcdStart) / gcdDuration * (Zombie_Resources.runeWidth + 2) * 6 - 2))
				gcdBar:EnableDrawLayer("BACKGROUND")
				gcdBar:EnableDrawLayer("BORDER")
			else
				gcdBar:DisableDrawLayer("BACKGROUND")
				gcdBar:DisableDrawLayer("BORDER")
			end
		end
        lastOnUpdate = 0
    end
end)

Zombie_ResourcesPanel:SetScript("OnEvent", function(self, event, ...) events[event](self, ...) end)
for k, v in pairs(events) do
    Zombie_ResourcesPanel:RegisterEvent(k)
end

function SlashCmdList.Zombie_Resources(msg, editbox)
    msg = { strsplit(" ", strlower(msg)) }
    if msg[1] == "runes" then
        if msg[2] then
			Zombie_Resources.runesOn = msg[2] == "on"
			SetVisibility()
		end
        print("Zombie Resources - Rune bars: " .. (Zombie_Resources.runesOn and "|cFF00C000On" or "|cFFC00000Off"))
	elseif msg[1] == "runic" then
        if msg[2] then
			Zombie_Resources.runicPowerOn = msg[2] == "on"
			SetVisibility()
		end
        print("Zombie Resources - Runic power bar: " .. (Zombie_Resources.runicPowerOn and "|cFF00C000On" or "|cFFC00000Off"))
	elseif msg[1] == "gcd" then
        if msg[2] then
			Zombie_Resources.gcdOn = msg[2] == "on"
			SetVisibility()
		end
        print("Zombie Resources - Global cooldown bar: " .. (Zombie_Resources.gcdOn and "|cFF00C000On" or "|cFFC00000Off"))
    elseif msg[1] == "locked" then
        if msg[2] then Zombie_Resources.locked = msg[2] == "on" end
        Zombie_ResourcesPanel:EnableMouse(not Zombie_Resources.locked)
        print("Zombie Resources - Locked: " .. (Zombie_Resources.locked and "|cFF00C000On" or "|cFFC00000Off"))
	elseif msg[1] == "scale" then
		if msg[2] then Zombie_Resources.scale = tonumber(msg[2]) or 1 end
		Zombie_ResourcesPanel:SetScale(Zombie_Resources.scale)
		print("Zombie Resources - Scale: |cFFFFD000" .. Zombie_Resources.scale .. "|r times")
    elseif msg[1] == "reset" then
		Zombie_ResourcesPanel:SetPoint("CENTER", 0, -209)
		print("Zombie Resources - Position reset")
    elseif msg[1] == "" then
        print("Zombie Resources (version: |cFFFFD000" .. GetAddOnMetadata("Zombie_Resources", "Version") .. "|r) - Commands:")
        print("  /zres runes |cFF00C000on|r/|cFFC00000off|r - hide or show the Zombie rune bars")
        print("  /zres runic |cFF00C000on|r/|cFFC00000off|r - hide or show the Zombie runic power bar")
		print("  /zres gcd |cFF00C000on|r/|cFFC00000off|r - hide or show the Zombie global cooldown bar")
        print("  /zres locked |cFF00C000on|r/|cFFC00000off|r - lock Zombie Resources so that it can't be moved")
		print("  /zres scale |cFFFFD000[number]|r - set the scale of Zombie Resources (1 = default)")
        print("  /zres reset - reset the location of Zombie Resources to default")
    end
end
